#include <stdio.h>
#include <stdarg.h>
#include "mwutil.h"

int cprintf (mw_CONST char *fmt, ...)
{
  va_list args;
  char    buf [CBUF_SIZE];
  int     len;

  va_start (args, fmt);

#if defined(WIN32)
  len = _vsnprintf (buf, sizeof(buf)-1, fmt, args);
#elif defined(__HIGHC__) || defined(__WATCOMC__)
  len = _vbprintf (buf, sizeof(buf)-1, fmt, args);
#elif defined(__DMC__)
  len = _vsnprintf (buf, sizeof(buf)-1, fmt, args);
#else
  len = vsprintf (buf, fmt, args);
#endif

  cputs (buf);
  va_end (args);
  return (len);
}
