include mwutil.ah

PUBLIC @ConioWriteFar, @ConioReadFar
PUBLIC @setup_fs, @restore_fs, @moveto_fs

comment ~
ifdef ??version         ; Turbo Assembler
  REPE_MOVB macro
            repe movsb
            endm

  REPE_MOVD macro
            repe movsd
            endm
else
~
  REPE_MOVSB macro        ; WASM doesn't handle "REPE MOVSx" (bug?)
             db 0F3h, 0A4h
             endm

  REPE_MOVSD macro
             db 0F3h, 0A5h
             endm
; endif

_DATA segment
           align 4
 fs_save   dw 0
_DATA ends

_TEXT segment

;----------------------------------------------------------------------
; ConioWriteFar (BYTE _far *dest, BYTE *src, int len)
;
        align 4
@ConioWriteFar:
        push esi
        push edi
        push es
        les  edi, [esp+12+4]    ; dest
        mov  esi, [esp+12+12]   ; src
        mov  ecx, [esp+12+16]   ; len
        mov  eax, ecx
        shr  ecx, 2
        cld
        rep  movsd
        mov  ecx, eax
        and  ecx, 3
        rep  movsb
        pop  es
        pop  edi
        pop  esi
        ret

;----------------------------------------------------------------------
; ConioReadFar (BYTE *dest, BYTE _far *src, int len)
;
        align 4
@ConioReadFar:
        push esi
        push edi
        push ds
        mov  edi, [esp+12+4]        ; dest
        lds  esi, [esp+12+8]        ; src
        mov  ecx, [esp+12+16]       ; len
        mov  eax, ecx
        shr  ecx, 2
        cld
        rep  movsd
        mov  ecx, eax
        and  ecx, 3
        rep  movsb
        pop  ds
        pop  edi
        pop  esi
        ret

;----------------------------------------------------------------------
; setup & restore FS for screen writing

        align 4
@setup_fs:
        mov fs_save, fs
        mov ax, SS_DOSMEM
        mov fs, ax
        ret

@restore_fs:
        mov fs, fs_save
        ret

;----------------------------------------------------------------------
; Perform "mov word ptr fs:[ofs],value"
;
; void moveto_fs (unsigned ofs, WORD value);
;
        align 4
@moveto_fs:
        mov ecx, [esp+4]
        mov eax, [esp+8]
        mov fs:[ecx], ax
        ret

_TEXT ends

end

