include mwutil.ah

PUBLIC @FastFillFar, @FastFillNear

_DATA segment
      extrn @scr_fp  : pword
      extrn @line_ofs: dword
_DATA ends

_TEXT segment

;---------------------------------------------------------------
;
; void cdecl FastFillFar (int x, int y, BYTE ch, int col, int num);
;
; Fill a screen line with num character/colour pairs

        align 4
@FastFillFar:
        push es
        push edi
        les  edi, @scr_fp              ; ES:EDI -> screen start
        mov  ecx, [esp+8+8]            ; ECX = y
        add  edi, @line_ofs[4*ecx]     ; EDI = _line_ofs[y]
        add  edi, [esp+8+4]            ; EDI = _line_ofs[y] + x
        add  edi, [esp+8+4]            ; EDI = _line_ofs[y] + x + x
        mov  al, [esp+8+12]            ; AL = character to fill
        mov  ah, [esp+8+16]            ; AH = fill color
        mov  ecx, [esp+8+20]           ; # of characters to fill
        cld
        rep  stosw
        pop  edi
        pop  es
        ret


;---------------------------------------------------------------
;
; void cdecl FastFillNear (int x, int y, BYTE ch, int col, int num);
;
; As above, but doesn't setup far pointer. Requires screen mapping
; to be active (or crash is guaranteed).

        align 4
@FastFillNear:
        push edi
        mov  ecx, [esp+4+8]            ; ECX = y
        mov  edi, @_mw_ti.mapping_scr
        add  edi, @line_ofs[4*ecx]     ; EDI = _line_ofs[y]
        add  edi, [esp+4+4]            ; EDI = _line_ofs[y] + x
        add  edi, [esp+4+4]            ; EDI = _line_ofs[y] + x + x
        mov  al, [esp+4+12]            ; AL = character to fill
        mov  ah, [esp+4+16]            ; AH = fill color
        mov  ecx, [esp+4+20]           ; # of characters to fill
        cld
        rep  stosw
        pop  edi
        ret

_TEXT ends
end

