include mwutil.ah

_TEXT segment

extrn  @conio_init  : near
extrn  @directcursor: dword
public _gotoxy, @gotoxy_abs

;-------------------------------------------------------------
; void gotoxy (int x, int y);
;
; Moves the cursor to a (X,Y) screen position by using the
; fastest alternative. Coordinates (X,Y) are relative to values
; in @_mw_ti

_gotoxy:
        call @conio_init
        mov  dl, [esp+4]               ; DL = X
        mov  dh, [esp+8]               ; DH = Y
        mov  @_mw_ti.curx, dl          ; store in screen-info
        mov  @_mw_ti.cury, dh

        add  dl, @_mw_ti.winleft       ; make absolute X
        add  dh, @_mw_ti.wintop        ; make absolute Y
        sub  edx, 0202h

        cmp  @directcursor, 0          ; move cursor using BIOS?
        je   gotoXY_BIOS               ; yes
      ; jmp  short gotoXY_direct       ; no, use fast direct version
      ; fall-through

;------------------------------------------------------------------------
;
; Move the screen cursor by directly manipulating the CRT controller
;
; In  : DL = X, DH = Y
; Out : EAX,ECX changed

        align 4
gotoXY_direct:
        push edx                       ; save (X,Y)
        xor  eax, eax
        mov  al, dh
        mul  @_mw_ti.screenwidth
        add  al, dl
        adc  eax, 0                    ; EAX = x + y*screenwidth
        mov  ecx, eax                  ; save xy ofs in ECX

        mov  dx, @CRT_base
        mov  al, 0Eh
        out  dx, al                    ; outportb(CRT_base,0x0E);
        jmp  $+2

        inc  dx
        mov  al, ch
        out  dx, al                    ; outportb(CRT_base+1,xy >> 8);
        jmp  $+2

        dec  dx
        mov  al, 0Fh
        out  dx, al                    ; outportb(CRT_base,0x0F);
        jmp  $+2

        inc  dx
        mov  al, cl
        out  dx, al                    ; outportb(CRT_base+1,xy & 0xFF);

        pop  edx                       ; restore (X,Y)
        movzx eax, @screen_page
ifdef DOS4G
        mov  [450h+2*eax], dx          ; save new pos in BIOS
else
        push es
        mov  cx, SS_DOSMEM
        mov  es, cx
        mov  es:[450h+2*eax], dx
        pop  es
endif
        ret

;-------------------------------------------------------------
; void gotoxy_abs (int x, int y);
;
; Moves the cursor to a (X,Y) screen position by using the
; fastest alternative. Coordinates (X,Y) are absolute

@gotoxy_abs:
        mov dl, [esp+4]                ; DL = X
        mov dh, [esp+8]                ; DH = Y
        cmp @directcursor, 0           ; move cursor using BIOS?
        jne gotoXY_direct              ; no, use fast direct version
      ; jmp short gotoXY_BIOS          ; yes
      ; fall-through


;----------------------------------------------------------------------
; gotoXY_BIOS.
; In :  DL=X, DH=Y
;
; Moves the cursor to a absolute screen position by calling BIOS
;
        align 4
gotoXY_BIOS:
        push esi
        push edi
        push ebx
        mov  bh, byte ptr @screen_page ; slow BIOS version
        mov  ah, 2
        int  10h
        pop  ebx
        pop  edi
        pop  esi
        ret

_TEXT ends
end
