#
# Makefile for Metaware CONIO (PharLap 386|DosX).
#
# MwCONIO is Copyright (c) Gisle Vanem 1997
#
# Created  25.June 1997
#
# This makefile requires a Borland compatible make tool
#

OBJDIR = metaware

.AUTODEPEND
.SWAP
.PATH.OBJ = $(OBJDIR)

CC       = hc386
CXX      = hc386
CFLAGS   = @$(OBJDIR)\conio.cfg -Hcplus
CXXFLAGS = CFLAGS

OBJS = attrib1.obj  attrib2.obj  cgets.obj   clreol.obj  clrscr.obj \
       cprintf.obj  cputs.obj    cscanf.obj  cursor.obj  delay.obj  \
       delline.obj  getch.obj    insline.obj mwconio.obj putch.obj  \
       sound.obj    textmode.obj textrec.obj window.obj  write.obj  \
       bios.obj     data.obj     farmem.obj  fill.obj    gotoxy.obj \
       inp.obj      inpw.obj     kbhit.obj   outp.obj    outpw.obj  \
       timer.obj    un_00.obj    un_01.obj   un_02.obj   un_03.obj  \
       un_04.obj    un_05.obj    un_06.obj   un_07.obj   un_08.obj  \
       un_09.obj    un_10.obj    un_11.obj   un_12.obj   un_13.obj  \
       wherexy.obj

LFLAGS = -lib conio,hc386,hc387,dosx32                    \
         -offset 1000h -stack 30000 -386 -twocase -nostub \
         -unprivileged -fullwarn -maxdata 0 -pack         \
         -fullseg -symbols -publist both -purge none *    \
         -mapnames 30 -mapwidth 132  \
         -attributes class CODE   er \
         -attributes group CGROUP er \
         -attributes class DATA   rw \
         -attributes class CONST  rw \
         -attributes class BSS    rw \
         -attributes class STACK  rw \
         -attributes group DGROUP rw


all       : conio.lib test.exp speed.exp

conio.lib : $(OBJDIR)\conio.cfg  $(OBJS)
            @cd $(OBJDIR)
            386lib ..\conio.lib @&&|
              -nowarn -nobackup -twocase -replace $(OBJS)
|
            @cd ..


test.exp  : conio.lib $(OBJDIR)\test.obj
            386link   $(OBJDIR)\test.obj -exe $< @&&|
              $(LFLAGS)
|

speed.exp : conio.lib $(OBJDIR)\speed.obj
            386link   $(OBJDIR)\speed.obj -exe $< @&&|
              $(LFLAGS)
|

#
# djgpp test programs for comparision of features
#
speed32.exe : speed.c
            gcc -s -O2 -Wall speed.c -o speed32.exe

test32.exe : test.cpp
            gcc -s -O2 -Wall test.c -o test32.exe


#
# Compile rules
#
$(OBJDIR)\speed.obj: speed.c
            $(CC) -c $(CFLAGS) -o $*.obj $?

$(OBJDIR)\test.obj: test.cpp
            $(CC) -c $(CFLAGS) -o $*.obj $?

.c.obj:
            $(CC) -c $(CFLAGS) -o $(OBJDIR)\$*.obj $*.c

.cpp.obj:
            $(CXX) -c $(CXXFLAGS) -o $(OBJDIR)\$*.obj $*.cpp

.asm.obj:
            tasm /t /l /mx $*.asm, $(OBJDIR)\$*.obj, $(OBJDIR)\$*.lst

clean:
            @del $(OBJDIR)\*.obj
            @del $(OBJDIR)\*.lst
            @del $(OBJDIR)\conio.cfg
            @del speed.map
            @del test.map
            @del conio.lib

zip:
            pkzip mwcon14 -P @&&|
             file_id.diz
             readme.1st
             makefile.*
             conio.txt
             conio.lib
             dos4g.w3r\conio.lib
             dos4g.w3r\delete.me
             dos4g.w3s\conio.lib
             dos4g.w3s\delete.me
             pharlap.w3r\conio.lib
             pharlap.w3r\delete.me
             pharlap.w3s\conio.lib
             pharlap.w3s\delete.me
             metaware\delete.me
             *.c
             *.cpp
             *.h
             *.asm
             *.ah
             *.ex?
|


$(OBJDIR)\conio.cfg : makefile.hc
  @copy /q &&|
   -DMSDOS
   -DPHARLAP                  # HighC can only use Pharlap extender
#  -DUSE_BIOS_SCROLL          # use BIOS for scrolling
   -w3                        # warning level
   -g                         # include debug info
   -486                       # optimize for 80486
   -O2                        # optimize level 2
   -Hnocopyr                  # don't show startup banner
   -Hnoswap                   # don't swap driver to disk
   -Hon=relax_func_ptr_rules  # don't be so picky
   -Hon=Recognize_library     # make memcpy/strlen etc. inline
   -Hon=Preload_args_from_memory
   -Hoff=Use_frame_pointer
   -Hon=char_is_rep
   -Hon=quiet
   -Hoff=Behaved
   -Hoff=check_stack          # (don't) generate stack-check code
| $<

