#ifndef _mwconio_util_h
#define _mwconio_util_h

#include <stdio.h>
#include <malloc.h>
#include <string.h>

#if defined(MSDOS) && \
    (defined(__WATCOMC__) && !defined(PHARLAP)) || \
    (defined(__DMC__) && defined(DOS386))

  #include <dos.h>
  #include <stddef.h>

  #if defined(__WATCOMC__)
    #include <i86.h>
    #pragma intrinsic (memset,memcpy)
  #endif

  #pragma pack(1)
  typedef struct {
          unsigned long  edi;
          unsigned long  esi;
          unsigned long  ebp;
          unsigned long  reserved;
          unsigned long  ebx;
          unsigned long  edx;
          unsigned long  ecx;
          unsigned long  eax;
          unsigned short flags;
          unsigned short es, ds, fs, gs;
          unsigned short ip, cs, sp, ss;
        } SWI_REGS;
  #pragma pack()

  void _dx_real_int (int inum, SWI_REGS *regs);

#elif defined(MSDOS)
  #include <pharlap.h>

#elif defined(WIN32)
  #define WIN32_LEAN_AND_MEAN
  #include <windows.h>
#endif

#if defined(__WATCOMC__) && defined(MSDOS)
  #include <conio.h>  /* inp(), outp() etc. */
#endif

#include "mw/conio.h"

#if defined(MSDOS)
  #define SCROLL_UP_FN     0x601
  #define SCROLL_DN_FN     0x701
  #define CLEAR_SCR_FN     0x700
#endif

#define CBUF_SIZE        2048
#define loBYTE(w)        (BYTE)(w)
#define hiBYTE(w)        (BYTE)((WORD)(w) >> 8)
#define MAX_SCR_WIDTH    132
#define MAX_SCR_HEIGHT   64

#if !defined(WIN32)
  typedef unsigned char   BYTE;
  typedef unsigned short  WORD;
  typedef unsigned long   DWORD;
  typedef int             BOOL;

  #define GetVideoOfs(x,y) (((x) << 1) + line_ofs[y])
#endif

#if defined(__HIGHC__)
  #pragma Global_aliasing_convention("_%r")
#endif

extern struct text_info _mw_ti;

#if defined(MSDOS)
  extern WORD       screen_seg;
  extern WORD       screen_start;
  extern WORD       screen_page;
  extern WORD       CRT_base;
  extern DWORD      linear_scr;
  extern DWORD      tinfo_size;
  extern void     (*yield_proc)(void);
  extern BYTE _far *scr_fp;         /* far-pointer screen access */
  extern BYTE      *scr_np;         /* near pointer screen access */
  extern int       char_avail;

#elif defined(WIN32)
  extern HANDLE _mw_hStdin, _mw_hStdout, _mw_hStderr;
  extern int    _mw_kbhit_count;
  extern CONSOLE_SCREEN_BUFFER_INFO _mw_csbi;
#endif

extern DWORD line_ofs [MAX_SCR_HEIGHT];
extern int   conio_reinit;

void  conio_init     (void);
void  soundBell      (void);
void  soundBell_BIOS (void);
DWORD FastWrite      (int x, int y, int col, const char *str);
void  ChangeAttr     (int x, int y, int num, int col);
void  ChangeFore     (int x, int y, int num, int col);
void  ChangeBack     (int x, int y, int num, int col);
void  gotoxy_abs     (int x, int y);
WORD  wherexy_abs    (void);

#if defined(PHARLAP)
  void* ConioWriteFar (BYTE _far *dest, BYTE *src, int len);
  void* ConioReadFar  (BYTE *dest, BYTE _far *src, int len);

  void setup_fs   (void); /* "helpers" for FastWrite()  */
  void restore_fs (void);
  void moveto_fs  (unsigned ofs, WORD value);
#endif

#if defined(MSDOS)
  WORD  FastFillFar   (int x, int y, BYTE ch, int col, int n);
  WORD  FastFillNear  (int x, int y, BYTE ch, int col, int n);
  void  write_ch_BIOS (int c, int col);

  /* implemented in TIMER.ASM
   */
  void  SetHiResTimer  (void);
  DWORD GetHiResTimer  (void);
  DWORD Get_BIOS_time  (void);
  DWORD GetMilliSec    (void);
  DWORD StartHiResTimer(void);
  DWORD StopHiResTimer (void);
#endif

#if defined(MSDOS)

  /* Screen scroll up/down macros; 1 line only
   */
  #define BIOS_SCROLL(func, x1, y1, x2, y2, col) do { \
          SWI_REGS reg;                               \
          reg.eax = func;                             \
          reg.ebx = (col) << 8;                       \
          reg.ecx = ((x1)-1) + (((y1)-1) << 8);       \
          reg.edx = ((x2)-1) + (((y2)-1) << 8);       \
          _dx_real_int (0x10, &reg);                  \
        } while (0)

  #if defined(USE_BIOS_SCROLL)
    #define SCROLL_UP(x1, y1, x2, y2, col);   \
            BIOS_SCROLL (SCROLL_UP_FN, x1, y1, x2, y2, col)

    #define SCROLL_DOWN(x1, y1, x2, y2, col) \
            BIOS_SCROLL (SCROLL_DN_FN, x1, y1, x2, y2, col)
  #else
    #define SCROLL_UP(x1, y1, x2, y2, col) do {            \
            int width = (x2)-(x1)+1;                       \
            movetext (x1, y1+1, x2, y2, x1, y1);           \
            SCREEN_FILL ((x1)-1, (y2)-1, ' ', col, width); \
          } while (0)

    #define SCROLL_DOWN(x1, y1, x2, y2, col) do {          \
            int width = (x2)-(x1)+1;                       \
            movetext (x1, y1, x2, (y2)-1, x1, (y1)+1);     \
            SCREEN_FILL ((x1)-1, y1, ' ', col, width);     \
          } while (0)
  #endif  /* USE_BIOS_SCROLL */

  /* Near or far screen read/write/fill macros
   */

  #if defined(PHARLAP)
    #define SCREEN_WRITE(dst, src, len)                                  \
          ( _mw_ti.mapping_scr                                   ?       \
            memcpy ((void*)(_mw_ti.mapping_scr + dst), src, len) :       \
            ConioWriteFar ((BYTE _far*)(scr_fp + dst), (BYTE*)(src), len) )

    #define SCREEN_READ(dst, src, len)                             \
          ( _mw_ti.mapping_scr                                   ? \
            memcpy (dst, (void*)(_mw_ti.mapping_scr + src), len) : \
            ConioReadFar ((BYTE*)(dst), (BYTE _far*)(scr_fp + src), len) )

  #else  /* DOS4GW/X32 */

    #define SCREEN_WRITE(dst, src, len) \
            memcpy ((void*)(scr_np + dst), src, len)

    #define SCREEN_READ(dst, src, len) \
            memcpy (dst, (const void*)(scr_np + src), len)
  #endif

  #define SCREEN_FILL(x1, y1, chr, col, num)            \
        ( _mw_ti.mapping_scr                  ?         \
          FastFillNear (x1, y1, chr, (int)(col), num) : \
          FastFillFar  (x1, y1, chr, (int)(col), num) )

#elif defined(WIN32)

  /* Blank area on line at coord (x,y)
   */
  #define SCREEN_FILL(x, y, chr, col, num) do {         \
          DWORD written;                                \
          COORD coord;                                  \
          coord.X = x;                                  \
          coord.Y = (SHORT)(y + _mw_csbi.srWindow.Top); \
          FillConsoleOutputCharacter (_mw_hStdout, chr, num, coord, &written); \
          FillConsoleOutputAttribute (_mw_hStdout, col, num, coord, &written); \
        } while (0)

  #define SCROLLER(x1, y1, x2, y2, col, lines) do { \
          SMALL_RECT r;                             \
          CHAR_INFO  ci;                            \
          COORD      dest;                          \
          r.Left   = (x1)-1;                        \
          r.Right  = (x2)-1;                        \
          r.Top    = (y1)-1;                        \
          r.Bottom = (y2)-1;                        \
          ci.Char.AsciiChar = ' ';                  \
          ci.Attributes = col;                      \
          dest.X = (x1)-1;                          \
          dest.Y = (y1)-1-(lines);                  \
          ScrollConsoleScreenBuffer (_mw_hStdout, &r, &r, dest, &ci); \
        } while (0)

  #define SCROLL_UP(x1, y1, x2, y2, col) \
          SCROLLER (x1, (SHORT)(y1 + _mw_csbi.srWindow.Top), \
                    x2, (SHORT)(y2 + _mw_csbi.srWindow.Top), col, 1)

  #define SCROLL_DOWN(x1, y1, x2, y2, col)  \
          SCROLLER (x1, (SHORT)(y1 + _mw_csbi.srWindow.Top), \
                    x2, (SHORT)(y2 + _mw_csbi.srWindow.Top), col, -1)

#else
  #error Yikes!!
#endif

/*
 * Internal tracing facility (WIN32 only)
 */
#if defined(WIN32)
  void mw_trace (const char *fmt, ...)
  #if defined(__GNUC__)
     __attribute__((format(printf,1,2)))
  #endif
  ;

  extern FILE *_mw_debug_file;
  extern int   _mw_debug_level;

  #define TRACE(fmt)  do {                                     \
                        if (_mw_debug_file) {                  \
                            mw_trace ("%s(): ", __FUNCTION__); \
                            mw_trace fmt;                      \
                            fputc ('\n', _mw_debug_file);      \
                        }                                      \
                      } while (0)
#else
  #define TRACE(fmt)  ((void)0)
#endif

/*
 * Prefix internal public names with "@"
 */
#if defined(__HIGHC__)
  #define RENAME_SYM(x)   pragma Alias(x, "@" #x "")

  RENAME_SYM (_mw_ti);
  RENAME_SYM (tinfo_size);
  RENAME_SYM (screen_seg);
  RENAME_SYM (screen_start);
  RENAME_SYM (screen_page);
  RENAME_SYM (CRT_base);
  RENAME_SYM (linear_scr);
  RENAME_SYM (scr_fp);
  RENAME_SYM (scr_np);
  RENAME_SYM (conio_reinit);
  RENAME_SYM (line_ofs);
  RENAME_SYM (yield_proc);

  RENAME_SYM (conio_init);
  RENAME_SYM (soundBell);
  RENAME_SYM (soundBell_BIOS);
  RENAME_SYM (write_ch_BIOS);
  RENAME_SYM (gotoxy_abs);
  RENAME_SYM (wherexy_abs);
  RENAME_SYM (ConioWriteFar);
  RENAME_SYM (ConioReadFar);
  RENAME_SYM (FastFillFar);
  RENAME_SYM (FastFillNear);
  RENAME_SYM (SetHiResTimer);
  RENAME_SYM (GetHiResTimer);
  RENAME_SYM (Get_BIOS_time);
  RENAME_SYM (GetMilliSec);
  RENAME_SYM (StartHiResTimer);
  RENAME_SYM (StopHiResTimer);
  RENAME_SYM (setup_fs);
  RENAME_SYM (restore_fs);
  RENAME_SYM (moveto_fs);

  #pragma Global_aliasing_convention()

#elif defined(__DMC__)
  #pragma alias (_mw_ti,         "@_mw_ti")
  #pragma alias (tinfo_size,     "@tinfo_size")
  #pragma alias (screen_seg,     "@screen_seg")
  #pragma alias (screen_start,   "@screen_start")
  #pragma alias (screen_page,    "@screen_page")
  #pragma alias (CRT_base,       "@CRT_base")
  #pragma alias (linear_scr,     "@linear_scr")
  #pragma alias (scr_fp,         "@scr_fp")
  #pragma alias (scr_np,         "@scr_np")
  #pragma alias (conio_reinit,   "@conio_reinit")
  #pragma alias (line_ofs,       "@line_ofs")
  #pragma alias (yield_proc,     "@yield_proc")
  #pragma alias (conio_init,     "@conio_init")
  #pragma alias (soundBell,      "@soundBell")
  #pragma alias (soundBell_BIOS, "@soundBell_BIOS")
  #pragma alias (write_ch_BIOS,  "@write_ch_BIOS")
  #pragma alias (gotoxy_abs,     "@gotoxy_abs")
  #pragma alias (wherexy_abs,    "@wherexy_abs")
  #pragma alias (FastFillFar,    "@FastFillFar")
  #pragma alias (FastFillNear,   "@FastFillNear")
  #pragma alias (SetHiResTimer,  "@SetHiResTimer")
  #pragma alias (GetHiResTimer,  "@GetHiResTimer")
  #pragma alias (Get_BIOS_time,  "@Get_BIOS_time")
  #pragma alias (GetMilliSec,    "@GetMilliSec")
  #pragma alias (StartHiResTimer,"@StartHiResTimer")
  #pragma alias (StopHiResTimer, "@StopHiResTimer")

  #ifdef PHARLAP
    #pragma alias (ConioWriteFar, "@ConioWriteFar")
    #pragma alias (ConioReadFar,  "@ConioReadFar")
    #pragma alias (setup_fs,      "@setup_fs")
    #pragma alias (restore_fs,    "@restore_fs")
    #pragma alias (moveto_fs,     "@moveto_fs")
  #endif

#elif defined(__WATCOMC__)
  #pragma aux ConioWriteFar   "@*" parm caller [] modify [eax ecx]
  #pragma aux ConioReadFar    "@*" parm caller [] modify [eax ecx]
  #pragma aux setup_fs        "@*" parm caller [] modify [ax]
  #pragma aux restore_fs      "@*" parm caller [] modify []
  #pragma aux moveto_fs       "@*" parm caller [] modify [eax ecx]
  #pragma aux FastFillFar     "@*" parm caller [] modify [eax ecx]
  #pragma aux FastFillNear    "@*" parm caller [] modify [eax ecx]
  #pragma aux write_ch_BIOS   "@*" parm caller [] modify [eax ecx]
  #pragma aux gotoxy_abs      "@*" parm caller [] modify [eax ecx edx]
  #pragma aux wherexy_abs     "@*" parm caller [] modify [eax]
  #pragma aux SetHiResTimer   "@*" parm caller [] modify [al]
  #pragma aux GetHiResTimer   "@*" parm caller [] modify [eax edx]
  #pragma aux Get_BIOS_time   "@*" parm caller [] modify [eax]
  #pragma aux GetMilliSec     "@*" parm caller [] modify [eax ecx edx]
  #pragma aux StartHiResTimer "@*" parm caller [] modify [eax ecx edx]
  #pragma aux StopHiResTimer  "@*" parm caller [] modify [eax ecx edx]
  #pragma aux conio_init      "@*" parm caller [] modify [eax ecx edx]
  #pragma aux soundBell       "@*" parm caller [] modify [eax ecx edx]
  #pragma aux soundBell_BIOS  "@*" parm caller [] modify [eax ecx edx]

  #pragma aux _mw_ti          "@*"
  #pragma aux tinfo_size      "@*"
  #pragma aux screen_seg      "@*"
  #pragma aux screen_start    "@*"
  #pragma aux screen_page     "@*"
  #pragma aux CRT_base        "@*"
  #pragma aux linear_scr      "@*"
  #pragma aux scr_fp          "@*"
  #pragma aux scr_np          "@*"
  #pragma aux conio_reinit    "@*"
  #pragma aux line_ofs        "@*"
  #pragma aux yield_proc      "@*"
  #pragma aux char_avail      "@*"
#endif

#endif  /* _mwconio_util_h */

